#include <string>
#include <iostream>

#define ANZAHL_KOMVERB  2
#define ANZAHL_ADRESSEN 2
#define ANZAHL_PERSONEN 1

using namespace std;

enum   KomVerbindungsTyp { Tel, Fax, Mobil, Email };
struct KomVerbindung     { KomVerbindungsTyp eTyp; string sNummer; };
struct Datum             { int nTag; string sMonat; int nJahr; };
struct Adresse           { string sStrasse; int nHausnummer;
                           string sPostleitzahl; string sOrt;
                           KomVerbindung aKommunikation [ANZAHL_KOMVERB]; };
struct Person            { string sVorname; string sNachname;
                           Datum rGeburtsdatum; KomVerbindung rKommunikation;
                           Adresse aAdressen[ANZAHL_ADRESSEN]; };
//-----------------------------------------------------------------------------
Person&        fnPersonEingeben        (Person&        pPerson);
Person*        fnPersonAusgeben        (Person*        pPerson);
Adresse&       fnAdresseEingeben       (Adresse&       pAdresse);
Adresse&       fnAdresseAusgeben       (Adresse&       pAdresse);
KomVerbindung& fnKomVerbindungEingeben (KomVerbindung& pKomVerbindung);
KomVerbindung& fnKomVerbindungAusgeben (KomVerbindung& pKomVerbindung);
Datum&         fnDatumEingeben         (Datum&         pDatum);
Datum&         fnDatumAusgeben         (Datum&         pDatum);

//=============================================================================
// Hauptprogramm
//=============================================================================
int main()
{
  Person aPerson [ANZAHL_PERSONEN];

  cout << "---------- EINGABEN --------------------------------------" << endl;
  for (int i=0; i<ANZAHL_PERSONEN; i++)
  {
    fnPersonEingeben (aPerson[i]);
  }
  cout << endl;

  cout << "---------- AUSGABEN --------------------------------------" << endl;
  for (int i=0; i<ANZAHL_PERSONEN; i++)
  {
    fnPersonAusgeben (&aPerson[i]); // oder: fnPersonAusgeben (aPerson+i);
  }
}

//=============================================================================
// Eingabe eines Datums ber Referenz (kann natrlich auch ber Pointer gelst
// werden
//=============================================================================
Datum& fnDatumEingeben (Datum& pDatum)
{
  cout << " Tag......(TT  z.B. 21): "; cin >> pDatum.nTag;
  cout << " Monat...(MMM z.B. Feb): "; cin >> pDatum.sMonat;
  cout << " Jahr..(JJJJ z.B. 1980): "; cin >> pDatum.nJahr;
  return pDatum;
}

//=============================================================================
// Ausgabe eines Datums ber Referenz (kann natrlich auch ber Pointer gelst
// werden
//=============================================================================
Datum& fnDatumAusgeben (Datum& pDatum)
{
  cout << " Datum.(TT.MMM.JJJJ): " << pDatum.nTag   << "."
                                   << pDatum.sMonat << "."
                                   << pDatum.nJahr  << endl;
  return pDatum;
}

//=============================================================================
// Eingabe einer Kommunikationsverbindung ber Referenz (kann natrlich auch
// ber Pointer gelst werden
//=============================================================================
KomVerbindung& fnKomVerbindungEingeben (KomVerbindung& pKomVerbindung)
{
  int nTemp;
  cout << " Verbindungsart (0=Tel, 1=Fax, 2=Handy, 3=E-Mail): "; cin >> nTemp;
  switch (nTemp)
  {
    default: pKomVerbindung.eTyp = Tel;   break;
    case  1: pKomVerbindung.eTyp = Fax;   break;
    case  2: pKomVerbindung.eTyp = Mobil; break;
    case  3: pKomVerbindung.eTyp = Email; break;
  }
  cout << " Verbindungsnummer / Mail-Adresse................: ";
  cin >> pKomVerbindung.sNummer;
  return pKomVerbindung;
}

//=============================================================================
// Ausgabe einer Kommunikationsverbindung ber Referenz (kann natrlich auch
// ber Pointer gelst werden
//=============================================================================
KomVerbindung& fnKomVerbindungAusgeben (KomVerbindung& pKomVerbindung)
{
  int nTemp;
  cout << " Art der Verbindung..............: ";
  switch (pKomVerbindung.eTyp)
  {
    case Tel  : cout << "Telefon" << endl; break;
    case Fax  : cout << "Fax"     << endl; break;
    case Mobil: cout << "Handy"   << endl; break;
    case Email: cout << "E-Mail"  << endl; break;
  }
  cout << " Verbindungsnummer / Mail-Adresse: " << pKomVerbindung.sNummer << endl;
  return pKomVerbindung;
}

//=============================================================================
// Eingabe einer Adresse ber Referenz (kann natrlich auch ber Pointer gelst
// werden
//=============================================================================
Adresse& fnAdresseEingeben (Adresse& pAdresse)
{
   cout << " Strasse............: "; cin >> pAdresse.sStrasse;
   cout << " Hausnummer...(Zahl): "; cin >> pAdresse.nHausnummer;
   cout << " Postleitzahl.......: "; cin >> pAdresse.sPostleitzahl;
   cout << " Ort................: "; cin >> pAdresse.sOrt;
   for (int i=0; i<ANZAHL_KOMVERB; i++)
   {
     fnKomVerbindungEingeben(pAdresse.aKommunikation[i]);
   }
   return pAdresse;
}

//=============================================================================
// Ausgabe einer Adresse ber Pointer, kann natrlich auch ber Referenz gelst
// werden
//=============================================================================
Adresse& fnAdresseAusgeben (Adresse& pAdresse)
{
   cout << " Strasse.....: " << pAdresse.sStrasse      << endl;
   cout << " Hausnummer..: " << pAdresse.nHausnummer   << endl;
   cout << " Postleitzahl: " << pAdresse.sPostleitzahl << endl;
   cout << " Ort.........: " << pAdresse.sOrt          << endl;
   for (int i=0; i<ANZAHL_KOMVERB; i++)
   {
     fnKomVerbindungAusgeben(pAdresse.aKommunikation[i]);
   }
  return pAdresse;
}

//=============================================================================
// Eingabe einer Person ber Referenz (kann natrlich auch ber Pointer gelst
// werden
//=============================================================================
Person& fnPersonEingeben (Person& pPerson)
{
  int nTemp;
  cout << " Nachname: "; cin >> pPerson.sNachname;
  cout << " Vorname.: "; cin >> pPerson.sVorname;
  fnDatumEingeben         (pPerson.rGeburtsdatum);
  fnKomVerbindungEingeben (pPerson.rKommunikation);
  for (int i=0; i<ANZAHL_ADRESSEN; i++)
  {
    fnAdresseEingeben(pPerson.aAdressen[i]);
  }
  return pPerson;
}

//=============================================================================
// Ausgabe einer Person ber Pointer, kann natrlich auch ber Referenz gelst
// werden
//=============================================================================
Person* fnPersonAusgeben (Person* pPerson)
{
  cout << " Vorname.: " << pPerson->sVorname  << endl;
  cout << " Nachname: " << pPerson->sNachname << endl;
  fnDatumAusgeben        (pPerson->rGeburtsdatum);
  fnKomVerbindungAusgeben(pPerson->rKommunikation);
  for (int i=0; i<ANZAHL_ADRESSEN; i++)
  {
    fnAdresseAusgeben(pPerson->aAdressen[i]);
  }
  return pPerson;
}

